package run.evan.chargetool;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import java.lang.reflect.Method;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Timer;
import java.util.TimerTask;

import run.evan.chargetool.databinding.MainActivityBinding;

public class MainActivity extends Activity {

    private static final int CHARGE_FULL_DESIGN_MI14P = 4880000;

    private MainActivityBinding binding;


    Object IMiChargeInstance;


    Method setNightChargeStatus;

    Method getNightChargeStatus;

    Method getUsbVoltage;

    Method getUsbCurrent;

    Method getBatteryCycleCount;

    Method getInputSuspendState;

    Method setInputSuspendState;

    Method getBatteryChargeFull;

    Method getBatteryCapacity;

    Method getBatteryAuthentic;

    Method getTxAdapt;

    Method getBtTransferStartState;

    Method getBatteryIbat;

    Method getBatteryVbat;

    Method getBatteryTbat;

    Method getMiChargePath;

    Method setMiChargePath;

    Method getBatterySoh;

    

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = MainActivityBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());

        try {
            Class IMiCharge = Class.forName("miui.util.IMiCharge");
            Method getInstance = IMiCharge.getDeclaredMethod("getInstance");
            getInstance.setAccessible(true);
            IMiChargeInstance = getInstance.invoke(null);
            getNightChargeStatus = IMiCharge.getDeclaredMethod("getNightChargingState");
            getNightChargeStatus.setAccessible(true);
            setNightChargeStatus = IMiCharge.getDeclaredMethod("setNightChargingState", int.class);
            setNightChargeStatus.setAccessible(true);
            getUsbVoltage = IMiCharge.getDeclaredMethod("getUsbVoltage");
            getUsbVoltage.setAccessible(true);
            getUsbCurrent = IMiCharge.getDeclaredMethod("getUsbCurrent");
            getUsbCurrent.setAccessible(true);
            getBatteryCycleCount = IMiCharge.getDeclaredMethod("getBatteryCycleCount");
            getBatteryCycleCount.setAccessible(true);
            getInputSuspendState = IMiCharge.getDeclaredMethod("getInputSuspendState");
            getInputSuspendState.setAccessible(true);
            setInputSuspendState = IMiCharge.getDeclaredMethod("setInputSuspendState", String.class);
            setInputSuspendState.setAccessible(true);
            getBatteryChargeFull = IMiCharge.getDeclaredMethod("getBatteryChargeFull");
            getBatteryChargeFull.setAccessible(true);
            getBatteryCapacity = IMiCharge.getDeclaredMethod("getBatteryCapacity");
            getBatteryCapacity.setAccessible(true);
            getBatteryAuthentic = IMiCharge.getDeclaredMethod("getBatteryAuthentic");
            getBatteryAuthentic.setAccessible(true);
            getTxAdapt = IMiCharge.getDeclaredMethod("getTxAdapt");
            getTxAdapt.setAccessible(true);
            getBtTransferStartState = IMiCharge.getDeclaredMethod("getBtTransferStartState");
            getBtTransferStartState.setAccessible(true);
            getBatteryIbat = IMiCharge.getDeclaredMethod("getBatteryIbat");
            getBatteryIbat.setAccessible(true);
            getBatteryVbat = IMiCharge.getDeclaredMethod("getBatteryVbat");
            getBatteryVbat.setAccessible(true);
            getBatteryTbat = IMiCharge.getDeclaredMethod("getBatteryTbat");
            getBatteryTbat.setAccessible(true);
            getMiChargePath = IMiCharge.getDeclaredMethod("getMiChargePath",String.class);
            getMiChargePath.setAccessible(true);
            setMiChargePath = IMiCharge.getDeclaredMethod("setMiChargePath",String.class,String.class);
            setMiChargePath.setAccessible(true);
            getBatterySoh = IMiCharge.getDeclaredMethod("getBatterySoh");
            getBatterySoh.setAccessible(true);

        } catch (Exception e) {
            binding.textView.setText(e.toString());
        }

        refresh();


        binding.switchStopCharge.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                boolean checked = binding.switchStopCharge.isChecked();

                try {
                    Boolean invoke = (Boolean) setMiChargePath.invoke(IMiChargeInstance, "smart_chg",checked ? "0x3" : "0x2");
                    if (invoke.booleanValue()) {
                        Toast.makeText(getApplicationContext(), "Success", Toast.LENGTH_SHORT).show();
                    } else {
                        Toast.makeText(getApplicationContext(), "Failed", Toast.LENGTH_SHORT).show();
                    }
                } catch (Exception e) {
                    binding.textView.setText(e.toString());
                }
            }
        });

        binding.switchDisableUsb.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                boolean checked = binding.switchDisableUsb.isChecked();
                try {
                    Boolean invoke = (Boolean) setInputSuspendState.invoke(IMiChargeInstance, checked ? "1" : "0");
                    if (invoke.booleanValue()) {
                        Toast.makeText(getApplicationContext(), "Success", Toast.LENGTH_SHORT).show();
                    } else {
                        Toast.makeText(getApplicationContext(), "Failed", Toast.LENGTH_SHORT).show();
                    }
                } catch (Exception e) {
                    binding.textView.setText(e.toString());
                }
            }
        });


        Timer timer = new Timer();
        TimerTask task = new TimerTask() {
            @Override
            public void run() {
                try {
                    BigDecimal voltage = new BigDecimal((String) getBatteryVbat.invoke(IMiChargeInstance));
                    BigDecimal current = new BigDecimal((String) getBatteryIbat.invoke(IMiChargeInstance));
                    BigDecimal v = voltage.divide(BigDecimal.valueOf(1000 * 1000), 4, RoundingMode.CEILING);
                    BigDecimal a = current.divide(BigDecimal.valueOf(1000 * 1000), 4, RoundingMode.CEILING);
                    binding.textBat.setText("Battery V=" + v.stripTrailingZeros().toPlainString() + "V  I=" + a.stripTrailingZeros().toPlainString() + "A");
                    binding.textPower.setText("Battery Power=" + v.multiply(a).stripTrailingZeros().toPlainString() + "W");
                    float temp = Integer.parseInt((String) getBatteryTbat.invoke(IMiChargeInstance)) / 10f;
                    binding.textTemp.setText("Battery Temp=" + temp);
                } catch (Exception e) {

                }
                try {
                    BigDecimal voltage = new BigDecimal((String) getUsbVoltage.invoke(IMiChargeInstance));
                    BigDecimal current = new BigDecimal((String) getUsbCurrent.invoke(IMiChargeInstance));
                    BigDecimal v = voltage.divide(BigDecimal.valueOf(1000 * 1000), 4, RoundingMode.CEILING);
                    BigDecimal a = current.divide(BigDecimal.valueOf(1000 * 1000), 4, RoundingMode.CEILING);
                    binding.textUsb.setText("USB V=" + v.stripTrailingZeros().toPlainString() + "V  I=" + a.stripTrailingZeros().toPlainString() + "A");
                    binding.textUsbPower.setText("USB Power=" + v.multiply(a).stripTrailingZeros().toPlainString() + "W");
                } catch (Exception e) {

                }

            }
        };
        timer.schedule(task, 0, 1000);

    }

    @Override
    protected void onResume() {
        super.onResume();
        refresh();
    }

    private void refresh() {
        try {
            String suspendResult = (String) getInputSuspendState.invoke(IMiChargeInstance);
            if ("1".equals(suspendResult)) {
                binding.switchDisableUsb.setChecked(true);
            } else {
                binding.switchDisableUsb.setChecked(false);
            }

            String pathResult = (String) getMiChargePath.invoke(IMiChargeInstance,"smart_chg");
            //binding.textView.setText(pathResult);
            if ("2".equals(pathResult) || "6".equals(pathResult)) {
                binding.switchStopCharge.setChecked(true);
            } else {
                binding.switchStopCharge.setChecked(false);
            }

            binding.textCycle.setText("Cycle Count=" + getBatteryCycleCount.invoke(IMiChargeInstance).toString());
            int chargeFull = Integer.parseInt(getBatteryChargeFull.invoke(IMiChargeInstance).toString());
            String life = BigDecimal.valueOf(chargeFull).divide(BigDecimal.valueOf(CHARGE_FULL_DESIGN_MI14P),4,RoundingMode.FLOOR).multiply(BigDecimal.valueOf(100)).stripTrailingZeros().toPlainString();
            binding.textLife.setText("Battery Life: " + (chargeFull/1000) + "mAh / " + (CHARGE_FULL_DESIGN_MI14P/1000) + "mAh = " + life + "%");
        } catch (Exception e) {
            binding.textView.setText(e.toString());
        }
    }

}
